library(spdep)
library(maptools)
library(INLA)

load("peerj_simdat.Rdata")
#####INLA GAMMA PRIORS####


f2<-simdig~hisp+hospdens+povz+consz+metro+
  f(year, model="iid",hyper = list(theta=list(prior="loggamma", param=c(.5, .0005))))+
  f(region.struct, model="bym", graph = "/Users/ozd504/Google Drive/cancerwork/peerj/tx.gra", hyper = list(theta1=list(prior="loggamma", param=c(.5, .0005)),theta2=list(prior="loggamma", param=c(.5, .0005))))+
  #f(fip2, hisp, model="iid",hyper = list(theta=list(prior="loggamma", param=c(.5, .0005))))+
  f(spid, model="iid",hyper = list(theta=list(prior="loggamma", param=c(.5, .0005))))

f2r<-simres~hisp+hospdens+povz+consz+metro+
  f(year, model="iid",hyper = list(theta=list(prior="loggamma", param=c(.5, .0005))))+
  f(region.struct, model="bym", graph = "/Users/ozd504/Google Drive/cancerwork/peerj/tx.gra", hyper = list(theta1=list(prior="loggamma", param=c(.5, .0005)),theta2=list(prior="loggamma", param=c(.5, .0005))))+
  # f(fip2, hisp, model="iid")+
  f(spid, model="iid",hyper = list(theta=list(prior="loggamma", param=c(.5, .0005))))

fit2<-inla(f2, family = "poisson", E =dig_e, data = peerj_simdat, control.compute=list(dic=T, config=T), control.predictor=list(link=1))
fit2r<-inla(f2r, family = "poisson", E =res_e, data = peerj_simdat, control.compute=list(dic=T, config=T))
fit2$summary.fixed[, c(1,3,5)]
summary(fit2r)
fit2$dic$dic;fit2r$dic$dic

f3<-simdig~hisp+hospdens+povz+consz+metro+
  f(year, model="iid",hyper = list(theta=list(prior="loggamma", param=c(.5, .0005))))+
  f(region.struct, model="bym", graph = "/Users/ozd504/Google Drive/cancerwork/peerj/tx.gra", hyper = list(theta1=list(prior="loggamma", param=c(.5, .0005)),theta2=list(prior="loggamma", param=c(.5, .0005))))+
  f(fip2, hisp, model="iid",hyper = list(theta=list(prior="loggamma", param=c(.5, .0005))))+
  f(spid, model="iid",hyper = list(theta=list(prior="loggamma", param=c(.5, .0005))))

f3r<-simres~hisp+hospdens+povz+consz+metro+
  f(year, model="iid",hyper = list(theta=list(prior="loggamma", param=c(.5, .0005))))+
  f(region.struct, model="bym", graph = "/Users/ozd504/Google Drive/cancerwork/peerj/tx.gra", hyper = list(theta1=list(prior="loggamma", param=c(.5, .0005)),theta2=list(prior="loggamma", param=c(.5, .0005))))+
  f(fip2, hisp, model="iid")+
  f(spid, model="iid",hyper = list(theta=list(prior="loggamma", param=c(.5, .0005))))

fit3<-inla(f3, family = "poisson", E =dig_e, data = peerj_simdat, control.compute=list(dic=T))
fit3r<-inla(f3r, family = "poisson", E =res_e, data = peerj_simdat, control.compute=list(dic=T))
summary(fit3)
summary(fit3r)
fit3$dic$dic;fit3r$dic$dic


f4<-simdig~hisp+hospdens+povz+consz+metro+
  f(year, model="iid",hyper = list(theta=list(prior="loggamma", param=c(.5, .0005))))+
  f(region.struct, model="bym", graph = "/Users/ozd504/Google Drive/cancerwork/peerj/tx.gra", hyper = list(theta1=list(prior="loggamma", param=c(.5, .0005)),theta2=list(prior="loggamma", param=c(.5, .0005))))+
  f(struct2, hisp, model="besag",graph = "/Users/ozd504/Google Drive/cancerwork/peerj/tx.gra",hyper = list(theta=list(prior="loggamma", param=c(.5, .0005))))+
  f(spid, model="iid",hyper = list(theta=list(prior="loggamma", param=c(.5, .0005))))

f4r<-simres~hisp+hospdens+povz+consz+metro+
  f(year, model="iid",hyper = list(theta=list(prior="loggamma", param=c(.5, .0005))))+
  f(region.struct, model="bym", graph = "/Users/ozd504/Google Drive/cancerwork/peerj/tx.gra", hyper = list(theta1=list(prior="loggamma", param=c(.5, .0005)),theta2=list(prior="loggamma", param=c(.5, .0005))))+
  f(struct2, hisp, model="besag",graph = "/Users/ozd504/Google Drive/cancerwork/peerj/tx.gra",hyper = list(theta=list(prior="loggamma", param=c(.5, .0005))))+
  f(spid, model="iid",hyper = list(theta=list(prior="loggamma", param=c(.5, .0005))))

fit4<-inla(f4, family = "poisson", E =dig_e, data = peerj_simdat, control.compute=list(dic=T))
fit4r<-inla(f4r, family = "poisson", E =res_e, data = peerj_simdat, control.compute=list(dic=T))
summary(fit4)
summary(fit4r)


fit2$dic$dic;fit2r$dic$dic
fit3$dic$dic;fit3r$dic$dic
fit4$dic$dic;fit4r$dic$dic


####INLA FLAT PRIORS####

f2f<-simdig~hisp+hospdens+povz+consz+metro+
  f(year, model="iid",hyper = list(theta=list(prior="flat",param = numeric())))+
  f(region.struct, model="bym", graph = "/Users/ozd504/Google Drive/cancerwork/peerj/tx.gra", hyper = list(theta1=list(prior="flat",param = numeric()),theta2=list(prior="flat",param = numeric())))+
  f(spid, model="iid",hyper = list(theta=list(prior="flat",param = numeric())))
#+  f(fip2, hisp, model="iid",hyper = list(theta=list(prior="flat",param = numeric())))
f2rf<-simres~hisp+hospdens+povz+consz+metro+
  f(year, model="iid",hyper = list(theta=list(prior="flat",param = numeric())))+
  f(region.struct, model="bym", graph = "/Users/ozd504/Google Drive/cancerwork/peerj/tx.gra", hyper = list(theta1=list(prior="flat",param = numeric()),theta2=list(prior="flat",param = numeric())))+
  f(spid, model="iid",hyper = list(theta=list(prior="flat",param = numeric())))
#+  f(fip2, hisp, model="iid")
fit2f<-inla(f2f, family = "poisson", E =dig_e, data = peerj_simdat, control.compute=list(dic=T))
fit2rf<-inla(f2rf, family = "poisson", E =res_e, data = peerj_simdat, control.compute=list(dic=T))
summary(fit2f)
summary(fit2rf)
fit2f$dic$dic;fit2rf$dic$dic

f3f<-simdig~hisp+hospdens+povz+consz+metro+
  f(year, model="iid",hyper = list(theta=list(prior="flat",param = numeric())))+
  f(region.struct, model="bym", graph = "/Users/ozd504/Google Drive/cancerwork/peerj/tx.gra", hyper = list(theta1=list(prior="flat",param = numeric()),theta2=list(prior="flat",param = numeric())))+
  f(fip2, hisp, model="iid",hyper = list(theta=list(prior="flat",param = numeric())))+
  f(spid, model="iid",hyper = list(theta=list(prior="flat",param = numeric())))
f3rf<-simres~hisp+hospdens+povz+consz+metro+
  f(year, model="iid",hyper = list(theta=list(prior="flat",param = numeric())))+
  f(region.struct, model="bym", graph = "/Users/ozd504/Google Drive/cancerwork/peerj/tx.gra", hyper = list(theta1=list(prior="flat",param = numeric()),theta2=list(prior="flat",param = numeric())))+
  f(fip2, hisp, model="iid")+
  f(spid, model="iid",hyper = list(theta=list(prior="flat",param = numeric())))

fit3f<-inla(f3f, family = "poisson", E =dig_e, data = peerj_simdat, control.compute=list(dic=T))
fit3rf<-inla(f3rf, family = "poisson", E =res_e, data = peerj_simdat, control.compute=list(dic=T))
summary(fit3f)
summary(fit3rf)
fit3f$dic$dic;fit3rf$dic$dic


f4f<-simdig~hisp+hospdens+povz+consz+metro+
  f(year, model="iid",hyper = list(theta=list(prior="flat",param = numeric())))+
  f(region.struct, model="bym", graph = "/Users/ozd504/Google Drive/cancerwork/peerj/tx.gra", hyper = list(theta1=list(prior="flat",param = numeric()),theta2=list(prior="flat",param = numeric())))+
  f(struct2, hisp, model="besag",graph = "/Users/ozd504/Google Drive/cancerwork/peerj/tx.gra",hyper = list(theta=list(prior="flat",param = numeric())))+
  f(spid, model="iid",hyper = list(theta=list(prior="flat",param = numeric())))

f4rf<-simres~hisp+hospdens+povz+consz+metro+
  f(year, model="iid",hyper = list(theta=list(prior="flat",param = numeric())))+
  f(region.struct, model="bym", graph = "/Users/ozd504/Google Drive/cancerwork/peerj/tx.gra", hyper = list(theta1=list(prior="flat",param = numeric()),theta2=list(prior="flat",param = numeric())))+
  f(struct2, hisp, model="besag",graph = "/Users/ozd504/Google Drive/cancerwork/peerj/tx.gra",hyper = list(theta=list(prior="flat",param = numeric())))+
  f(spid, model="iid",hyper = list(theta=list(prior="flat",param = numeric())))

fit4f<-inla(f4f, family = "poisson", E =dig_e, data = peerj_simdat, control.compute=list(dic=T))
fit4rf<-inla(f4rf, family = "poisson", E =res_e, data = peerj_simdat, control.compute=list(dic=T))
summary(fit4f)
summary(fit4rf)


fit2f$dic$dic;fit2rf$dic$dic
fit3f$dic$dic;fit3rf$dic$dic
fit4f$dic$dic;fit4rf$dic$dic
